debug = false

require('menu')
-- require('menu/splash')
-- require('game/battle')
-- require('game/char_select')
require('controls')
-- require('game/post_game')
-- require('menu/options')
-- require('menu/tutorial/tutorial')

function love.load()
	love.mouse.setVisible(false)
	--load assets etc

	--Fonts
	-- silverlinkFont = love.graphics.newFont(50)
	-- regularFont = love.graphics.newFont(12)
	-- APFont = love.graphics.newFont("resources/fonts/accid___.ttf",30)

	-- --Images
	-- silverlinklogo = love.graphics.newImage("resources/images/silverlinklogo.png")
	-- makeshiftgameslogo = love.graphics.newImage("resources/images/makeshiftgameslogo.png")
	--Initialize state
	state = "menu"

	--============intialization===========--
	opacity = 0
	opacity_base = opacity
	reveal = false
	hide = false
	credit = {
		Number = 1,
		State = "Start",
		timer = 2
	}
	credit.timer_base = credit.timer
	

	screenWidth = love.graphics.getWidth()
	screenHeight = love.graphics.getHeight()
	string = ""

	--load the states
	menu.load()
	-- splash.load()
	controls.load()
	-- options.load()

end

function love.update(dt)
	if state == "credits" then
		if credit.State == "Start" then
			reveal = true
			credit.timer = credit.timer_base
		elseif credit.State == "Pause" then
			credit.timer = credit.timer - dt
			if credit.timer < 0 then
				credit.timer = 0
				credit.State = "End"
			end
		elseif credit.State == "End" then
			hide = true
		end

		if reveal then
			opacity = opacity + 200 * dt
			if opacity > 255 then
				opacity = 255
				reveal = not reveal
				credit.State = "Pause"
			end
		end

		if hide then
			opacity = opacity - 200 * dt
			if opacity < 0 then
				opacity = 0 
				hide = not hide
				credit.Number = credit.Number + 1
				credit.State = "Start"
			end
		end
		if credit.Number > 3 then
			state = "splash"
		end
	end

	-- if state == "splash" then
	-- 	splash.update(dt)
	if state == "menu" then
		menu.update(dt)
	-- elseif state == "controls" then
	-- 	controls.update(dt)
	-- elseif state == "tutorial" then
	-- 	tutorial.update(dt)
	-- elseif state == "char_select" then
	-- 	char_select.update(dt)
	-- elseif state == "battle" then
	-- 	battle.update(dt)
	-- elseif state == "post_game" then
	-- 	post_game.update(dt)
	end
end

function love.draw()
	--draws the background for the intial credits
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle("fill",0,0,love.graphics.getWidth(), love.graphics.getHeight())

	--draws credits
	if state == "credits" then
		love.graphics.setColor(255,255,255, opacity)
		love.graphics.setFont(APFont)
		-- if credit.Number == 1 then
		-- 	love.graphics.printf("This game is based on the light novel written by Kenji Inoue.", 0, screenHeight/2 - regularFont:getHeight()/2, screenWidth,"center")
		-- elseif credit.Number == 2 then
		-- 	love.graphics.draw(silverlinklogo, screenWidth/2 - silverlinklogo:getWidth()/2, screenHeight/2 - silverlinklogo:getHeight()/2) 
		-- elseif credit.Number == 3 then
		-- 	love.graphics.draw(makeshiftgameslogo, screenWidth/2 - makeshiftgameslogo:getWidth()/2, screenHeight/2 - makeshiftgameslogo:getHeight()/2) 
		-- end
	end
	
	if state == "menu" then
		menu.draw()
	-- elseif state == "splash" then
	-- 	splash.draw()
	-- elseif state == "controls" then
	-- 	controls.draw()
	-- elseif state == "char_select" then
	-- 	char_select.draw()
	-- elseif state == "battle" then
	-- 	battle.draw()
	-- elseif state == "post_game" then
	-- 	post_game.draw()
	end

	if debug then
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(regularFont)
		if state == "credits" then
			love.graphics.setColor(255,255,255)
		elseif state == "menu" or state == "splash" then
			love.graphics.setColor(0,0,0)
		end
		love.graphics.print("||========DEBUG MODE========||", 50, 50)
		love.graphics.print("State: " ..state, 50, 80)
		love.graphics.print(string, 50,105)
	end
end

function love.keypressed(key, unicode)
	if key == "tab" then
		debug = not debug
	end

	string = key

	if state == "credits" then
		if key == "return" or key == " " then
			credit.Number = credit.Number + 1
			credit.State = "Start"
			opacity = opacity_base
			hide = false
		end
	end

	if state == "menu" then
		menu.keypressed(key, unicode)
	-- elseif state == "splash" then
	-- 	splash.keypressed(key, unicode)
	-- elseif state == "controls" then
	-- 	controls.keypressed(key, unicode)
	-- elseif state == "char_select" then
	-- 	char_select.keypressed(key, unicode)
	-- elseif state == "battle" then
	-- 	battle.keypressed(key, unicode)
	-- elseif state == "post_game" then
	-- 	post_game.keypressed(key, unicode)
	end


end
